--
--
-- EXAMPLE CHAT SERVER
--
--

-- Define constants and stuff like that here
-- is usefull for database connections
predefine = "ECHOSRV: "
myClients = {}

-- Main function, needs to be defined.
-- Gets called when a client submits
-- something to the server.

-- Respond using
-- _send(clientId, message): Send to a specific user
-- _sendAll(message): Send to all users
function main (clientId, message)
    --_send(clientId, predefine .. message)
    --_sendAll("Broadcast: " .. message)

	-- check for commands
	if string.sub (message, 0, 1) == "/" then
		if string.find (message, "/nickname", 0, 10) then
			oldname = myClients[clientId]["name"]
			
			myClients[clientId]["name"] = string.sub(message, 10)
			_send(clientId, "Your nickname has been set to " .. myClients[clientId]["name"])
			_sendAll(oldname .. " is now known as " .. myClients[clientId]["name"])
		end

	else
		_sendAll(myClients[clientId]["name"] .. ": " .. message)
	end

end


-- Gets called when a client disconnects
function on_disconnect(clientId)
    print("clientID " .. clientId .. " quit.")
	_sendAll("ClientID " .. clientId .. " just quit the server")

	myClients[clientId] = nil
end

-- Gets called when a client connects
function on_connect(clientId)
    print("clientID ".. clientId .. " connected.")
	_sendAll("ClientID " .. clientId .. " just joined the server")

	myClients[clientId] = {name = 'noname'}
end

-- This is just there to see that you
-- loaded the complete lua
print("Lua is loaded.")
